function y = BarrierImpliedVolBisection(S,K,r,q,T,a,b,MarketPrice,Tol,MaxIter,Barrier,Rebate)

lowCdif  = MarketPrice - EuropeanDownAndOutCall(S,K,Barrier,r,q,a,T,Rebate);
highCdif = MarketPrice - EuropeanDownAndOutCall(S,K,Barrier,r,q,b,T,Rebate);

if (lowCdif * highCdif > 0)
    y = -1;
else
    for i = 1:MaxIter
        midP = (a + b) / 2;
        midCdif = MarketPrice - EuropeanDownAndOutCall(S,K,Barrier,r,q,midP,T,Rebate);
        if (abs(midCdif) < Tol)
            break
		end
        if (midCdif > 0)
            a = midP;
        else
            b = midP;
		end
    end
    y = midP;
end

