function y = BisecBSV(PutCall,S,K,r,q,T,a,b,MarketPrice,Tol,MaxIter)

BSCall = inline('s*exp(-q*T)*normcdf((log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T)) - K*exp(-r*T)*normcdf((log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T) - v*sqrt(T))',...
	     's','K','r','q','v','T');
BSPut = inline('K*exp(-r*T)*normcdf(-(log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T) + v*sqrt(T)) - s*exp(-q*T)*normcdf(-(log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T))',...
	   's','K','r','q','v','T');

if strcmp(PutCall,'C')
	lowCdif  = MarketPrice - BSCall(S,K,r,q,a,T);
	highCdif = MarketPrice - BSCall(S,K,r,q,b,T);
else
	lowCdif  = MarketPrice - BSPut(S,K,r,q,a,T);
	highCdif = MarketPrice - BSPut(S,K,r,q,b,T);
end	

if (lowCdif * highCdif > 0)
    y = -1;
else
    for i = 1:MaxIter
        midP = (a + b) / 2;
		if strcmp(PutCall,'C')
			midCdif = MarketPrice - BSCall(S,K,r,q,midP,T);
		else
			midCdif = MarketPrice -  BSPut(S,K,r,q,midP,T);
		end
        if (abs(midCdif) < Tol)
            break
		end
        if (midCdif > 0)
            a = midP;
        else
            b = midP;
		end
    end
    y = midP;
end
